#ifndef _Utils_H_
#define _Utils_H_

#undef DECL
#ifdef UTILS_DLL
#define DECL _declspec(dllexport)
#else
#define DECL _declspec(dllimport)
#endif

#ifdef _WIN32_WCE
#include <Xpert/io.h>
#endif 

// The global dll info structure.
extern AFX_EXTENSION_MODULE UtilsDLL;

extern "C" LPCTSTR DECL GetUtilsVersion();
extern "C" LPCTSTR DECL GetUtilsPath();

bool DECL inpn(DWORD Addr, void* Data, DWORD Len);
bool DECL outn(DWORD Addr, void* Data, DWORD Len);

inline BYTE inp(DWORD Addr)
{
#ifdef _WIN32_WCE
   return ReadByte(Addr);
#else
   return 0;
#endif
}

inline WORD inpw(DWORD Addr)
{
#ifdef _WIN32_WCE
   return ReadWord(Addr);
#else
   return 0;
#endif
}

inline DWORD inpd(DWORD Addr)
{
#ifdef _WIN32_WCE
   return ReadLong(Addr);
#else
   return 0;
#endif
}

inline bool out(DWORD Addr, BYTE Data)
{
#ifdef _WIN32_WCE
   WriteByte(Addr, Data);
   return true;
#else
   return false;
#endif
}

inline bool outw(DWORD Addr, WORD Data)
{
#ifdef _WIN32_WCE
   WriteWord(Addr, Data);
   return true;
#else
   return false;
#endif
}

inline bool outd(DWORD Addr, DWORD Data)
{
#ifdef _WIN32_WCE
   WriteLong(Addr, Data);
   return true;
#else
   return false;
#endif
}

CString DECL GetLastErrorMsg();

#endif
